/*==========================================================================
 *
 *  Copyleft (C) 2004 Computer Graphics NTU IM . All Rights "UN-Reserved".
 *
 *  File:       GraphicFrame.java
 *  Content:    read obj and tri fileformat
 *
 *  2004/9/24	Created by balana and Draphix
 *
 ***************************************************************************/
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.StringTokenizer;
import javax.swing.event.*;


public class GraphicFrame extends JFrame{
	
	int height=500,width=500;
	View gv;
	private JMenuBar mr = new JMenuBar();
	private JMenuItem openItem;
	private JFileChooser files;
	private File objfile;
	mymodel model;
	
	
	
	public GraphicFrame(String title){
		
		setTitle(title);
		setJMenuBar(mr);
		setDefaultCloseOperation(EXIT_ON_CLOSE);
		
		JMenu fileMenu = new JMenu("File");
		openItem = fileMenu.add("Open");
		openItem.addActionListener(new Filelistener());
		mr.add(fileMenu);
			
	}

	class Filelistener implements ActionListener {
		
		public void actionPerformed(ActionEvent e){
		
			int result = -1;
			files = new JFileChooser();
			files.setFileSelectionMode(files.FILES_ONLY);
			files.rescanCurrentDirectory();
			result = files.showOpenDialog(GraphicFrame.this);
		
			if(result==files.APPROVE_OPTION)
			{
				objfile = files.getSelectedFile();
				model= new mymodel();
				model.readfile(objfile);
				//gv.todraw
				//gv.repaint
			}
		}
	}//end of Filelistener
	
	
	public void setView(View gv){
		this.gv = gv;
	}

}

//===============================================

class myvector {
	double x;
	double y;
	double z;
}

class myface {
	int vindx[];
	int nindx[];
	double forecolor[];
	double backcolor[];
	
	public myface()
	{
		vindx = new int[3];
		nindx = new int[3];
		forecolor = new double[3];
		backcolor = new double[3];
	}
}

class mymodel
{
	myvector  vertexlist[];//put vertex data 
	myvector normallist[]; //put normal data
	myface	  facelist[];  //put face data
	
	int filemode = -1; //0 for tri , 1 for obj
	boolean tricolor = false;//true for tri_color false for tri_simple
	int numvertex=0,numnormal=0,numface=0;
	myvector min,max;                       
  myvector center; 	
	
	public void readfile(File objfile){
	try{
			FileReader fr = new FileReader(objfile);
			BufferedReader br = new BufferedReader(fr);
			StringTokenizer parse;
	
			String input;
			myvector tempv;
			myvector tempvn;
			myface tempf;
			int index = 0;
			int tempface = 0;
			String temp;

	   	br.mark(300);
	    input = br.readLine();
	    parse = new StringTokenizer(input);    
			temp = parse.nextToken();
	 
	 		//check what type the file is
	 		if(temp.equals("Triangle")){
	 			//tri
	 				filemode = 0 ;
	 				for(int w=0;w<4;w++)
	 					input = br.readLine();
		      parse = new StringTokenizer(input);
		      temp = parse.nextToken();
		      //check is tri_color or tri_simple
		      if(temp.equals("Triangle"))
		        	tricolor = false;
		      else tricolor = true;
		        	
		      br.reset();
		        	
		      //caculate face numer
		      for(input = br.readLine();input!=null;input = br.readLine())
		      	{
		       		parse = new StringTokenizer(input);
		       		temp = parse.nextToken();
		       		if(temp.equals("Triangle"))
		       		tempface++;
		      	}
		      
		      //allocate array
		      	numvertex=tempface*3;
		       	numnormal=tempface*3;
		       	numface=tempface;
		        	
		       	vertexlist = new myvector[numvertex];
		       	normallist = new myvector[numnormal];
		       	facelist  = new myface[numface];
		        	
		       	fr = new FileReader(objfile);
			      br = new BufferedReader(fr);
		           
		      	input = br.readLine();
		       	parse = new StringTokenizer(input);
		            	
				//put data into array
		     	for(;input!=null;)
		     	{
		       		if(parse.hasMoreTokens())
		           		temp = parse.nextToken();
		            		
		       		if(temp.equals("Triangle"))
		       		{
									//each triangle a time
									tempf = new myface();
									if(tricolor)
										{//save color if if tri_color
							
											input = br.readLine();
											parse = new StringTokenizer(input);
	
											temp = parse.nextToken();
											tempf.forecolor[0] = Double.parseDouble(temp);
											temp = parse.nextToken();
											tempf.forecolor[1] = Double.parseDouble(temp);
											temp = parse.nextToken();
											tempf.forecolor[2] = Double.parseDouble(temp);
							
											temp = parse.nextToken();
											tempf.backcolor[0] = Double.parseDouble(temp);
											temp = parse.nextToken();
											tempf.backcolor[1] = Double.parseDouble(temp);
											temp = parse.nextToken();
											tempf.backcolor[2] = Double.parseDouble(temp);
										}
						
									//put 3 vertex and normal 
										for(int i=0;i<3;i++){
											input = br.readLine();
											parse = new StringTokenizer(input);
							
											tempv = new myvector();
							
											temp = parse.nextToken();
											tempv.x = Double.parseDouble(temp);
											temp = parse.nextToken();
											tempv.y = Double.parseDouble(temp);
											temp = parse.nextToken();
											tempv.z = Double.parseDouble(temp);
											vertexlist[index*3+i] = tempv;
							
											tempv = new myvector();
							
											temp = parse.nextToken();
											tempv.x = Double.parseDouble(temp);
											temp = parse.nextToken();
											tempv.y = Double.parseDouble(temp);
											temp = parse.nextToken();
											tempv.z = Double.parseDouble(temp);
						
											normallist[index*3+i]=tempv;
							
										}	
					        		
					        		//set face vertex index and normal index
												tempf.vindx[0] = index*3;
												tempf.vindx[1] = index*3+1;
												tempf.vindx[2] = index*3+2;
						
												tempf.nindx[0] = index*3;
												tempf.nindx[1] = index*3+1;
												tempf.nindx[2] = index*3+2;
						
												facelist[index]=tempf;
												index++;
						     		
		        		}
		        		input = br.readLine();
		        		if(input!=null) parse = new StringTokenizer(input);
		        	}//end of for
	 			
	 		}
	 		else
	 		{				//obj
	 			    	int numberV =0;
	 			    	int numberVN = 0;
	 			    	int numberF = 0;
	 			    	
	 			    	filemode = 1;
	 			      br.reset();
		        	
	 			    	for(input = br.readLine();input!=null;input = br.readLine()){
		        		parse = new StringTokenizer(input);
		        		if(parse.hasMoreTokens())
		            {
		            		temp = parse.nextToken();
		        				if(temp.equals("v"))
		        				numberV++;
		        				else if(temp.equals("vn"))
		        				numberVN++;	
		        				else if(temp.equals("f"))
		        				numberF++;
		        			}
		        	}
		        	//allocate array
		        	vertexlist = new myvector[numberV];
		        	normallist = new myvector[numberVN];
		        	facelist  = new myface[numberF];
		        	
		        	numberV = numberVN = numberF =0;
		        	
		        	fr = new FileReader(objfile);
			        br = new BufferedReader(fr);
		          
		          for(input = br.readLine();input!=null;input = br.readLine())
		          {
		        		parse = new StringTokenizer(input);
		        		if(parse.hasMoreTokens())
		            {
		            
		        			temp = parse.nextToken();
		        	
		        			if(temp.equals("v"))
		        			{
		        				tempv = new myvector();
		        		
		        				temp = parse.nextToken();
		        				tempv.x = Double.parseDouble(temp);
		        				temp = parse.nextToken();
		        				tempv.y = Double.parseDouble(temp);
		        				temp = parse.nextToken();
		        				tempv.z = Double.parseDouble(temp);
		        		
		        				vertexlist[numberV]= tempv;
		        		
		        				numberV++;
		        			}
		        		else if(temp.equals("vn"))
		        		{
		        				tempvn = new myvector();
		        		
		        				temp = parse.nextToken();
		        				tempvn.x = Double.parseDouble(temp);
		        				temp = parse.nextToken();
		        				tempvn.y = Double.parseDouble(temp);
		        				temp = parse.nextToken();
		        				tempvn.z = Double.parseDouble(temp);
		        		
		        				normallist[numberVN]= tempvn;
		        		 		numberVN++;
		        		
		        		}
		        		else if(temp.equals("f"))
		        		{
		        				tempf = new myface();
		        				String st1 ;
		        				String st2 ;
		        		
		        				temp = parse.nextToken();
		        				index = temp.indexOf("//");
	 									st1 = temp.substring(0,index);
	 									st2 = temp.substring(index+2);
	 									tempf.vindx[0] = (Integer.parseInt(st1))-1;
	 									tempf.nindx[0] = (Integer.parseInt(st2))-1;
	 			
	 									temp = parse.nextToken();
		        				index = temp.indexOf("//");
	 									st1 = temp.substring(0,index);
	 									st2 = temp.substring(index+2);
	 									tempf.vindx[1] = (Integer.parseInt(st1))-1;
	 									tempf.nindx[1] = (Integer.parseInt(st2))-1;
	 			
	 									temp = parse.nextToken();
		        				index = temp.indexOf("//");
	 									st1 = temp.substring(0,index);
	 									st2 = temp.substring(index+2);
	 									tempf.vindx[2] = (Integer.parseInt(st1))-1;
	 									tempf.nindx[2] = (Integer.parseInt(st2))-1;
	 			
			 							facelist[numberF]= tempf;
		        		
				        		numberF++;
		        		
		        		
		        			}
		        		}//end of if(parse.hasMoreTokens())
		        	}//end of for loop	
	 		}//end of obj handling
	 	
			//gv.todraw();
			//gv.repaint();
		}//end of try
		catch(IOException e){
			System.out.println(e);
		}
		
	}//end of fileread  
	
	public void stat()//to caculate center and min and max 
	{
        	int i;
        	max.x = max.y = max.z = min.x = min.y = min.z = 0;
       		for(i=0;i<numvertex;i++){
                	if(vertexlist[i].x > max.x)
                        	max.x = vertexlist[i].x;
                	if(vertexlist[i].x < min.x)
                       		min.x = vertexlist[i].x;
                	if(vertexlist[i].y > max.y)
                        	max.y = vertexlist[i].y;
                	if(vertexlist[i].y < min.y)
                        	min.y = vertexlist[i].y;
                	if(vertexlist[i].z > max.z)
                        	max.z = vertexlist[i].z;
                	if(vertexlist[i].z < min.z)
                        	min.z = vertexlist[i].z;
       		}
        	
        	center.x = (max.x+min.x)/2;
        	center.y = (max.y+min.y)/2;
        	center.z = (max.z+min.z)/2;
	}
	
	public void unload(){//reset varialbes
		filemode = -1;
    numvertex = 0;
    numnormal = 0;
    numface = 0;
        	
    min.x = min.y = min.z = max.x = max.y = max.z = 0;

	}
}


